% . . Make Atoms
clear all;

% . . Set up Boundaries
xlen=12;
zlen=11;
tau=1;
gam=1;
High=0.1;
Low=10.1;
dz=.02;
topz=[0:dz:High High:-dz:0];
topx=[0:xlen-1];
botz=[-10:-dz:-Low -Low:dz:-10];
botx=[0:xlen-1];

Points(1:12,1,1 )=topx;
Points(1:12,1,2 )=topz;
Points(1:12,11,1)=botx;
Points(1:12,11,2)=botz;


XX=[0:xlen];
ZZ=[-1:-1:-9];
for ii=1:xlen
  for jj=2:zlen-1
  Points(ii,jj,1)=XX(ii);
  Points(ii,jj,2)=ZZ(jj-1);
  end 
end 

% . . Spring Constants
kt=1;
kg=1;
R=1;
AvePot=0;
eps=0.0001;

Mfrac=1;


figure(1)
subplot(2,1,1)
plot(Points(:,:,1),Points(:,:,2),'r.')
axis([-1 12 -16 6]);axis image

for nstep=1:2
  % . . Compute Potential Function
  for ii=1:xlen
    for jj=1:zlen
      if ii==1 
        if jj==1 % . . ii+1 jj+1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii+1,jj,:)-Points(ii,jj,:)))))+...
              R*abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:))));
          
        elseif jj==zlen % . . ii+1 jj-1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj-1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii+1,jj,:)-Points(ii,jj,:)))))+...
              R*abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:))));
       else % . .  jj-1 jj+1 ii+1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj-1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(tau-norm(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii+1,jj,:)-Points(ii,jj,:)))))+...
              R*(abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:))))+...
                 abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:)))))/2;

        end 
      elseif ii==xlen 
        if jj==1 % . .ii-1 jj+1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii-1,jj,:)-Points(ii,jj,:)))))+...
              R*abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:))));

        elseif jj==zlen % . . ii-1 jj-1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj-1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii-1,jj,:)-Points(ii,jj,:)))))+...
              R*abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:))));

        else % . .  ii-1 jj+1 jj-1
          Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj-1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(tau-norm(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)))))+...
                           kg*(abs(gam-norm(squeeze(Points(ii-1,jj,:)-Points(ii,jj,:)))))+...
            R*(abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:))))+...
               abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:)))))/2;
        end 
      elseif ii~=1 && ii~=xlen && jj~=1 && jj ~=zlen % . . ALL
        Potential(ii,jj)=kt*(abs(tau-norm(squeeze(Points(ii,jj-1,:)-Points(ii,jj,:)))))+...
                         kt*(abs(tau-norm(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)))))+...
                         kg*(abs(tau-norm(squeeze(Points(ii-1,jj,:)-Points(ii,jj,:)))))+...
                         kg*(abs(gam-norm(squeeze(Points(ii+1,jj,:)-Points(ii,jj,:)))))+...
             R*(abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:))))+...
                abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii+1,jj,:)-Points(ii,jj,:))))+...
                abs(dot(squeeze(Points(ii,jj+1,:)-Points(ii,jj,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:))))+...
                abs(dot(squeeze(Points(ii,jj,:)-Points(ii,jj-1,:)),squeeze(Points(ii,jj,:)-Points(ii-1,jj,:)))))/4;
  
      end 
    end
  end
%  Potential(1,:  )=Potential(2,:);
% Potential(end,:)=Potential(end-1,:);
%  Potential(:,1  )=Potential(:,2);
%  Potential(:,end)=Potential(:,end-1);
%Potential(1,:  )=AvePot;
%Potential(end,:)=AvePot;
%Potential(:,1  )=AvePot;
%Potential(:,end)=AvePot;
  
  % . . Take Gradient
  [FX,FY]=gradient(Potential,Points(ii,jj,1),Points(ii,jj,2));
  
  % . . Find Gradient Direction
  Dir=atan2(FY,FX);
  Mag=sqrt(FX.*FX+FY.*FY);
  MagMax=max(max(abs(Mag)));

  
  for ii=1:xlen
    for jj=2:zlen-1
      Xmove(ii,jj)=-Mfrac*gam*Mag(ii,jj)*sin(Dir(ii,jj));
      Zmove(ii,jj)=-Mfrac*tau*Mag(ii,jj)*cos(Dir(ii,jj));
      Points(ii,jj,1)=Points(ii,jj,1)+Xmove(ii,jj);
      Points(ii,jj,2)=Points(ii,jj,2)+Zmove(ii,jj);
    end
  end
  

end

figure(1)
subplot(2,1,2)
plot(Points(:,:,1),Points(:,:,2),'r.')
axis([-1 12 -16 6]);axis image