% . . Make Atoms
clear all;

% . . Set up Boundaries
gnum=20;
tnum=20;

for ii=1:gnum 
  borderz(ii            )=sub2ind([gnum tnum],ii,1);
  borderz(ii+gnum       )=sub2ind([gnum,tnum],ii,tnum);
end

for ii=1:tnum 
  borderx(ii            )=sub2ind([gnum tnum],1,ii);
  borderx(ii+tnum       )=sub2ind([gnum,tnum],gnum,ii);
end

dz=.2;

High= 10;
Low =-10;
Left=-10;
Right=10;

% . . High Perimeter
DZ=dz*(gnum-2)/2+High;
topz=[linspace(High,DZ,gnum/2)  linspace(DZ,High,gnum/2)];
topx=[linspace(Left,Right,gnum)];

% . . Low Perimeter
LZ=Low-dz*(gnum-2)/2;
botz=[linspace(Low,LZ,gnum/2)  linspace(LZ,Low,gnum/2)];
botx=[linspace(Left,Right,gnum)];

% . . Fix Points
GG(:,   1)=botx;
GG(:,gnum)=topx;
TT(:,   1)=botz;
TT(:,gnum)=topz;

% . . Interior Points
for jj=2:tnum-1
  GG(:,jj)=botx;
end
gint=GG(2,1)-GG(1,1);

ztemp=linspace(Low,High,tnum);
for ii=1:tnum
  TT(ii,2:tnum-1)=ztemp(2:tnum-1);
end 
tint=TT(5,2)-TT(5,1);


% . . Spring Constants
kt=1;
kg=1;
R=4;
totsteps=1;
dstep=0.05;


Mfrac=dstep*min(gint,tint);

eps=.0000000001;

% . . allocate arrays

for nstep=1:totsteps
   disp(['Working on step ',num2str(nstep),' of ',num2str(totsteps) ]);

   [dPdx,dPdz]=GetGradient(GG,TT,borderz,borderx,gint,tint,kt,kg);
   dPtot=sqrt(dPdx.^2+dPdz.^2);
   
   Xmove=Mfrac*dPdx./(dPtot+eps);   Xmove(borderz)=0.;
   Zmove=Mfrac*dPdz./(dPtot+eps);   Zmove(borderz)=0.;
  
   GG=GG+Xmove;
   TT=TT+Zmove;

end

figure(2)
plot(GG,TT,'r.')
axis([-1 12 -16 6]);axis image

