function [dPdx,dPdz]=GetGradient(GG,TT,borderz,borderx,tint,gint,kt,kg);
% . . Function that computes the gradients of molecule varables GG and TT
  
   gpx=diff(GG,1,1); gpx(size(GG,1),:)=0;
   tpx=diff(GG,1,2); tpx(:,size(GG,2))=0;
   gmx(2:size(GG,1),:)=-flipud(diff(flipud(GG),1,1));
   tmx(:,2:size(GG,2))=-fliplr(diff(fliplr(GG),1,2));
      
   gpz=diff(TT,1,1); gpz(size(TT,1),:)=0;
   tpz=diff(TT,1,2); tpz(:,size(TT,2))=0;
   gmz(2:size(TT,1),:)=-flipud(diff(flipud(TT),1,1));
   tmz(:,2:size(TT,2))=-fliplr(diff(fliplr(TT),1,2));

   D1= sqrt(  gpx.^2 + gpz.^2) -gint;
   D2= sqrt(  tpx.^2 + tpz.^2) -tint;
   D3= sqrt(  gmx.^2 + gmz.^2) -gint;
   D4= sqrt(  tmx.^2 + tmz.^2) -tint;

   SpringPot=kg*(D1+D3)+kt*(D2+D4);
   SpringPot(borderx(1:end/2))    =SpringPot(borderx(1:end/2)+1);
   SpringPot(borderx(end/2+1:end))=SpringPot(borderx(end/2+1:end)-1);
   SpringPot(borderz(1:end/2))    =SpringPot(borderz(1:end/2)+size(GG,1));
   SpringPot(borderz(end/2+1:end))=SpringPot(borderz(end/2+1:end)-size(GG,1));

   for ii=1:size(GG,1)
     dPdz(ii,:)=gradient(SpringPot(ii,:),TT(ii,:) );
   end
   for jj=1:size(TT,2)
     dPdx(:,jj)=gradient(SpringPot(:,jj),GG(:,jj) );
   end    

   figure(1)
   imagesc(SpringPot');colorbar;pause(.1) 
  
  