clear all;
file_name='Rays.3D.H';
D1=New_load_history(file_name);
fidd1=fopen(D1.in,'r','ieee-be');
arr_size=[D1.n(1),D1.n(2),D1.n(3)];
nelem=arr_size(1)*arr_size(2)*arr_size(3);
f(1:nelem) = fread(fidd1,nelem,'float32');
Data2Grid=reshape(f,[D1.n(1),D1.n(2),D1.n(3)]);

xx=([0:D1.nray(1)-1]*D1.dist(1)+D1.off(1))/1000;
yy=([0:D1.nray(2)-2]*D1.dist(2)+D1.off(2))/1000;

nskip=4
figure(1)
plot3(Data2Grid(:,1:nskip:end,2),40000-Data2Grid(:,1:nskip:end,3),Data2Grid(:,1:nskip:end,1) )
xlabel('Easting (m)')
ylabel('Southing (m)')
zlabel('Elevation (m)')
view(-10,-70);
axis tight;axis ij
print -depsc2 Rays3D.eps

Height=Data2Grid(:,:,1)/1000;
H2G = reshape(Height,[D1.n(1),D1.nray(1),D1.nray(2)]);
mhi=max(max(squeeze(H2G(1,:,:))));
mlo=min(min(squeeze(H2G(1,:,:))));

figure(4)
subplot(2,2,1)
colormap(flipud(gray))

Ltoplot=squeeze(H2G(1,:,:));
imagesc(xx,yy,Ltoplot - min(Ltoplot(:))  );
xlabel('Easting (km)')
ylabel('Southing (km)')
title('Elevation difference at \tau_0')
caxis([0 mhi]); colorbar

subplot(2,2,2)
colormap(flipud(gray))
Ltoplot=squeeze(H2G(66,:,:));
imagesc(xx,yy,Ltoplot -  min(Ltoplot(:)) );
xlabel('Easting (km)')
ylabel('Southing (km)')
title('Elevation difference at \tau_{N/3}')
caxis([0 mhi]);colorbar

subplot(2,2,3)
colormap(flipud(gray))
Ltoplot=squeeze(H2G(132,:,:));
imagesc(xx,yy,Ltoplot -  min(Ltoplot(:)) );
xlabel('Easting (km)')
ylabel('Southing (km)')
title('Elevation difference at \tau_{2N/3}')
caxis([0 mhi]);colorbar

subplot(2,2,4)
colormap(flipud(gray))
Ltoplot=squeeze(H2G(200,:,:));
imagesc(xx,yy,Ltoplot -  min(Ltoplot(:)) );
xlabel('Easting (km)')
ylabel('Southing (km)')
title('Elevation difference at \tau_{N}')
caxis([0 mhi]);colorbar

print -depsc2 ./Fig/Rays3D2.eps



wantrotmovie='n'
if wantrotmovie=='y' 
  figure(3)
  ii=1;
  for jj=1:4:360
     plot3(Data2Grid(:,1:nskip:end,2),Data2Grid(:,1:nskip:end,3),Data2Grid(:,1:nskip:end,1) )
     xlabel('Easting (m)')
     ylabel('Southing (m)')
     zlabel('Elevation (m)')
     view(jj,75);
     axis tight
     M(ii) = getframe;
     ii=ii+1
  end  
  movie(M)
end


Height=Data2Grid(:,:,1);
H2G = reshape(Height,[D1.n(1),D1.nray(1),D1.nray(2)]);

wantmovie='n'
if wantmovie=='y' 
figure(2)
mhi=max(max(squeeze(H2G(1,:,:))));
mlo=min(min(squeeze(H2G(1,:,:))));
ii=1;
for jj=1:2:size(H2G,1)
  jj
  Ltoplot=squeeze(H2G(jj,:,:));
  imagesc(xx,yy,Ltoplot - ( ( max(Ltoplot(:))+min(Ltoplot(:)) ))/2 );
  title(['Max-min elevation ',num2str( max(Ltoplot(:)) - min(Ltoplot(:)) )])
  caxis([mlo mhi]);
  M(ii) = getframe;
  ii=ii+1
end
movie(M)
end

